#
# spec file for package lam
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           lam
BuildRequires:  gcc-c++
BuildRequires:  gcc-fortran
BuildRequires:  gmp-devel
BuildRequires:  libtool
%define _sysconfdir /etc/lam
%define _romiodocdir /usr/share/lam/doc
# Other values may be passed in via:
#
# rpmbuild -define 'config_args ...'
#
# where "..." may be replaced with anything extra to pass to
# configure.  See conditionalbuilds(3) man page (note the
# misspelling!) for more details.
#
# Values specified here are what are used if the user does not pass in
# any defaults.
%{!?config_options: %define config_options ""}
%{!?rpi: %define rpi --with-rpi=usysv}
Summary:        Local Area Multicomputer
License:        Apache-1.1
Group:          Development/Libraries/Parallel
Version:        7.1.4
Release:        lp152.3.57
Url:            http://www.lam-mpi.org/
Source0:        http://www.lam-mpi.org/download/files/lam-%{version}.tar.bz2
Source1:        baselibs.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       openssh
Provides:       mpi
#Conflicts:    mpich mpich2
Patch:          lam-7.1.1_no_darwin.patch
Patch1:         lam-7.1.2_strncat_usage.patch
Patch2:         lam-7.1.4_gcc43_building.patch
Patch3:         lam-7.1.4_am111.patch
Patch4:         lam-7.1.4_free.patch

%description 
LAM (Local Area Multicomputer) is an MPI programming environment and
development system for heterogeneous computers on a network. With LAM,
a dedicated cluster or an existing network computing infrastructure can
act as one parallel computer solving one problem.

LAM features extensive debugging support in the application development
cycle and peak performance for production applications. LAM also
features a full implementation of the MPI (Message Passing Interface)
communication standard.  The documentation is installed in
/usr/share/doc/packages/lam/.

%package devel
Requires:       lam = %{version}
Conflicts:      mpich-manpages
Summary:        Local Area Multicomputer
Group:          Development/Libraries/Parallel
Obsoletes:      lam-manpages
Obsoletes:      lamman
Provides:       lam-manpages
Provides:       lamman
Requires:       glibc-devel
Requires:       libstdc++-devel

%description devel
LAM (Local Area Multicomputer) is an MPI programming environment and
development system for heterogeneous computers on a network. With LAM,
a dedicated cluster or an existing network computing infrastructure can
act as one parallel computer solving one problem.

LAM features extensive debugging support in the application development
cycle and peak performance for production applications. LAM features a
full implementation of the MPI (Message Passing Interface)
communication standard.  The documentation will be installed in
/usr/share/doc/packages/lam/

%prep
%setup -q
%patch
%patch1
%patch2
%patch3 -p1
%patch4

%build
autoreconf -fi
pushd share/ssi/coll/smp
touch NEWS README AUTHORS ChangeLog
autoreconf -fi
popd
export F77=gfortran
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure --disable-static --with-pic\
    %{rpi} \
    --with-purify \
    --enable-shared \
    --enable-tv-dll-force \
    --with-rsh="%{_bindir}/ssh -x"
make %{?_smp_mflags} all

%install
%makeinstall
for file in README README_LAM COPYRIGHT; do
	mv romio/$file romio/romio-$file
done
mv romio/doc/users-guide.ps.gz romio/doc/romio-users-guide.ps.gz
rm -f %{buildroot}%{_datadir}/lam/lam-shell-setup.sh
rm -f %{buildroot}%{_datadir}/lam/lam-shell-setup.csh
rm -f %{buildroot}%{_datadir}/lam/lam_module.tcl
rm -f %{buildroot}%{_mandir}/man1/wipe.1*
rm -f %{buildroot}%{_bindir}/wipe
find examples -name ".deps" | xargs rm -rfv
%{__rm} -f %{buildroot}%{_libdir}/*.la

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE HISTORY INSTALL README
%doc doc/*.pdf
%doc examples
%doc %{_romiodocdir}
%config %{_sysconfdir}
%{_bindir}/hboot
%{_bindir}/lamboot
%{_bindir}/lamclean
%{_bindir}/lamd
%{_bindir}/lamhalt
%{_bindir}/laminfo
%{_bindir}/lamnodes
%{_bindir}/lamwipe
%{_bindir}/mpirun
%{_bindir}/recon
%{_bindir}/tkill
%{_bindir}/tping
%dir %{_libdir}/lam
%{_libdir}/lam/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%dir %{_mandir}/mans
%{_mandir}/mans/*
%{_bindir}/lamgrow
%{_bindir}/lamexec
%{_bindir}/lamshrink
%{_bindir}/lamtrace
%{_bindir}/lamcheckpoint
%{_bindir}/lamrestart
%{_bindir}/mpiexec
%{_bindir}/mpimsg
%{_bindir}/mpitask
%dir /usr/share/lam
%{_libdir}/liblam.so.0
%{_libdir}/liblam.so.0.0.0
%{_libdir}/liblamf77mpi.so.0
%{_libdir}/liblamf77mpi.so.0.0.0
%{_libdir}/liblammpi++.so.0
%{_libdir}/liblammpi++.so.0.0.0
%{_libdir}/libmpi.so.0
%{_libdir}/libmpi.so.0.0.0

%files devel
%defattr(-,root,root)
%{_bindir}/hcc
%{_bindir}/hcp
%{_bindir}/hf77
%{_bindir}/mpiCC
%{_bindir}/mpic++
%{_bindir}/mpicc
%{_bindir}/mpif77
%{_includedir}/*
%{_mandir}/man3/*
%{_libdir}/liblam.so
%{_libdir}/liblamf77mpi.so
%{_libdir}/liblammpi++.so
%{_libdir}/liblammpio.a
%{_libdir}/libmpi.so

%changelog
* Tue May 21 2013 schwab@suse.de
- Force building totalview module
- Don't remove executable bit from totalview module, it has no effect
- lam-7.1.4_gcc43_building.patch: Remove bogus hunks
* Thu Jan 26 2012 cfarrell@suse.com
- license update: Apache-1.1
  The LAM license corresponds most closely to the Apache-1.1 (though there
  are minor differences). You should state CLEARLY in the spec file as a
  comment (directly above the License: line) that whereas the LAM license
  is very similar to the Apache license, there are some differences. The
  user should inspect the License file carefully
* Sun Nov 13 2011 jengelh@medozas.de
- Remove redundant/unwanted tags/section (cf. specfile guidelines)
- Use %%_smp_mflags for parallel building
* Sun Nov 13 2011 coolo@suse.com
- add libtool as explicit buildrequire to avoid implicit dependency from prjconf
* Thu Jun 17 2010 coolo@novell.com
- add baselibs.conf to make boost-32bit installable
* Mon Jun  7 2010 coolo@novell.com
- autoreconf subdir to fix parallel make
* Fri May 21 2010 bg@novell.com
- package files below /usr/lib/lam also on hppa
* Tue May 18 2010 mrueckert@suse.de
- added lam-7.1.4_free.patch: (bnc#471291)
  fix incorrect free call.
* Mon Feb  8 2010 jengelh@medozas.de
- package up files on SPARC
* Sat Jun 20 2009 coolo@novell.com
- fix build with automake 1.11
* Wed Mar 11 2009 crrodriguez@suse.de
- remove static libraries except liblammpio.a which is only available
  in static form.
- remove "la" files
* Fri May  9 2008 schwab@suse.de
- Use autoreconf -fi.
* Fri Nov  9 2007 mrueckert@suse.de
- added lam-7.1.4_gcc43_building.patch:
  fix the signature of main() in the configure checks
* Sun Aug  5 2007 mrueckert@suse.de
- update to 7.1.4:
  tons of bug fixes. see /usr/share/doc/packages/lam/HISTORY
- enabled purify
* Wed May 23 2007 dmueller@suse.de
- add ldconfig falls to %%post/%%postun
* Tue Jan 23 2007 mrueckert@suse.de
- added lam-7.1.2_strncat_usage.patch:
  fix potential buffer overflows.
* Fri Oct 20 2006 mrueckert@suse.de
- update to 7.1.2:
  tons of bug fixes.
- enabled shared libraries and moved static libs/la files into
  the devel package
* Tue Mar 28 2006 mrueckert@suse.de
- removed APSL licensed files
- added lam-7.1.1_no_darwin.patch:
  removed references to files in the build system
- cleaned up %%build/%%install
* Fri Feb 17 2006 ro@suse.de
- cleanup docs (remove .deps)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Jan 14 2006 kukuk@suse.de
- Add gmp-devel to nfb
* Wed Dec 21 2005 ro@suse.de
- remove unpackaged symlink /usr/bin/wipe
* Tue Nov 15 2005 uli@suse.de
- fixed to build on ARM
* Mon May  9 2005 ro@suse.de
- find new fortran
* Tue Apr 26 2005 nashif@suse.de
- Remove conflict to mpich (#66558)
* Tue Jan 25 2005 nashif@suse.de
- dont install deprecated man page for wipe
- remove modules file
* Mon Jan 24 2005 nashif@suse.de
- Update tp 7.1.1
* Tue Sep 14 2004 nashif@suse.de
- Update to 7.0.6
* Sun Aug 15 2004 ro@suse.de
- neededforbuild: follow rename of environment-modules to Modules
* Wed Jul 28 2004 bg@suse.de
- fix build for hppa
* Sat Apr 24 2004 nashif@suse.de
- Added -fno-strict-aliasing to CFLAGS
* Thu Feb 26 2004 nashif@suse.de
- update to 7.0.4
- updated docs
* Sat Jan 10 2004 adrian@suse.de
- add %%defattr
* Sat Oct  4 2003 nashif@suse.de
- Update to 7.0.2
* Tue Jul  1 2003 nashif@suse.de
- Update to 7.0 final
- Fix for various architectures
* Thu Jun 12 2003 nashif@suse.de
- Added created dirs to file list
* Thu May 29 2003 nashif@suse.de
- Update to 7.0b13
- Fix file list
* Wed May 21 2003 nashif@suse.de
- Update to 7.0b12, final following soon
* Wed Jan 29 2003 nashif@suse.de
- Update to version 6.5.9
* Thu Jan 16 2003 ro@suse.de
- fixed errno issues
* Thu Nov 14 2002 nashif@suse.de
- Update to version 6.5.8
* Sun Aug  4 2002 nashif@suse.de
- moved to /opt
- add module file
* Fri Feb  1 2002 nashif@suse.de
- Update to 6.5.6
* Wed Sep  5 2001 nashif@suse.de
- Added lam61.doc.pdf (Bug #10197)
* Wed Aug  1 2001 nashif@suse.de
- Update to version 6.5.4
* Fri Jul 20 2001 nashif@suse.de
- Update to new version 6.5.3
* Thu Jun 28 2001 nashif@suse.de
- Update to new version 6.5.2
* Thu Apr  5 2001 nashif@suse.de
- Added  --with-trillium to allow building of lam utility
  packages (xmpi, xmtv)
* Thu Apr  5 2001 nashif@suse.de
- Update to 6.5.1
* Tue Apr  3 2001 nashif@suse.de
- Update to version 6.5
* Thu Mar 15 2001 nashif@suse.de
- Use fpic for ia64
* Wed Mar  7 2001 ro@suse.de
- nkitb -> rsh
* Wed Mar  7 2001 nashif@suse.de
- Added nkitb to neededforbuild
* Sat Jan 20 2001 schwab@suse.de
- Add %%suse_update_config.
- Fix use of va_arg.
* Thu Nov 16 2000 nashif@suse.de
- Changed sup-package name lamman -> lam-manpages
- Spec cleanup
* Wed May 10 2000 nashif@suse.de
- Spec cleanup
- Now all files reside in /usr/lib/lam to avoid conflicts with other MPIs
* Thu Apr  6 2000 nashif@suse.de
- Update to 6.3.2
* Tue Jan 25 2000 uli@suse.de
- tprint.c: fixed misuse of va_arg macro
* Mon Jan 10 2000 nashif@suse.de
- Update to 6.3.1
* Fri Nov 26 1999 nashif@suse.de
-  Updated to 6.3
* Sun Nov  7 1999 nashif@suse.de
- Added g77 to requires
  - fixed a broken symbol link
  - misc minor fixes
* Sat Nov  6 1999 nashif@suse.de
- Add Conflicts: lam to spec
* Mon Nov  1 1999 nashif@suse.de
- Updated to version lam62b-p15
* Tue Oct 12 1999 nashif@suse.de
- Fixed symbolic links to be relative
* Thu Sep 30 1999 nashif@suse.de
- added --without-shortcircuit to configure to bypass
  problems with blacs and scalapack
  - Made LAM coexist with MPICH
  - seperated MAN pages from main package
  - common files with MPICH have the ending _lam
  - wipe is now lamwipe to avoid conflict with other packages
* Tue Sep 28 1999 nashif@suse.de
- update to lam62b-p14
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Mar 17 1999 werner@suse.de
- update to lam62b
* Mon Oct  5 1998 ro@suse.de
- sem_semun is not defined for glibc, so define...
* Mon Jun  8 1998 werner@suse.de
- New package: LAM/MPI
  (Local Area Machine/Message-Passing Interface)
